Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveCommunicator.cs	(revision 4423)
@@ -666,5 +738,4 @@
       JobDto job = DaoLocator.JobDao.FindById(jobId);
       if (job == null) {
-        //response.Success = false;
         response.StatusMessage = ResponseStatus.IsJobStillNeeded_JobDoesNotExist;
         Logger.Error("Job doesn't exist (anymore)! " + jobId);
@@ -672,5 +743,4 @@
       }
       if (job.State == JobState.Finished) {
-        //response.Success = true;
         response.StatusMessage = ResponseStatus.IsJobStillNeeded_JobAlreadyFinished;
         Logger.Error("already finished! " + job);
@@ -702,5 +772,4 @@
             response.List.Add(ConvertPluginDescriptorToDto(ipd));
           } else {
-            //response.Success = false;
             response.StatusMessage = ResponseStatus.GetPlugins_PluginsNotAvailable;
             return response;
@@ -722,5 +791,5 @@
       return currCachedPlugin;
     }
-    
+
     #endregion
   }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/SlaveManager.cs	(revision 4423)
@@ -165,5 +165,5 @@
         response.Obj = new SlaveGroupDtoList();
         //response.Success = false;
-        response.StatusMessage = ResponseStatus.GetAllGroupsOfResource_ResourceNotFound;
+        response.StatusMessage = ResponseStatus.GetAllGroupsOfResource_ResourceDoesNotExist;
       }
 
@@ -180,5 +180,5 @@
       }
 
-      DaoLocator.SlaveGroupDao.Delete(slaveGroup);
+      DaoLocator.SlaveGroupDao.Delete(slaveGroup.Id);
       return response;
     }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/HeuristicLab.Hive.Server.DataAccess-3.3.csproj
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/HeuristicLab.Hive.Server.DataAccess-3.3.csproj	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/HeuristicLab.Hive.Server.DataAccess-3.3.csproj	(revision 4423)
@@ -87,4 +87,5 @@
   <ItemGroup>
     <Compile Include="DataAccessException.cs" />
+    <Compile Include="IHiveExperimentDao.cs" />
     <Compile Include="ISlaveConfigDao.cs" />
     <Compile Include="ISlaveDao.cs" />
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IGenericDao.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IGenericDao.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IGenericDao.cs	(revision 4423)
@@ -9,5 +9,5 @@
     TBusiness Insert(TBusiness bObj);
     
-    void Delete(TBusiness bObj);
+    void Delete(Guid id);
 
     void Update(TBusiness bObj);
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IHiveExperimentDao.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IHiveExperimentDao.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.DataAccess/3.3/IHiveExperimentDao.cs	(revision 4423)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.DataAccess {
+  public interface IHiveExperimentDao : IGenericDao<HiveExperimentDto> {
+    IEnumerable<HiveExperimentDto> FindAllByUserId(Guid guid);
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/BaseDao.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/BaseDao.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/BaseDao.cs	(revision 4423)
@@ -31,7 +31,10 @@
           conflict.Resolve(RefreshMode.KeepChanges);
         }
-        //next round!
-        CommitChanges();
-        //Context.SubmitChanges(ConflictMode.FailOnFirstConflict);
+        try {
+          Context.SubmitChanges();
+        }
+        catch {
+          Logger.Error("Could not resolve conflict!");
+        }
       }
     }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/ContextFactory.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/ContextFactory.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/ContextFactory.cs	(revision 4423)
@@ -45,12 +45,12 @@
     public IDisposable GetContext(bool withTransaction) {
       lock (locker) {
-        Logger.Debug("opening transaction");
         int threadId = Thread.CurrentThread.ManagedThreadId;
 
         if (contexts.ContainsKey(threadId)) {
-          throw new DataAccessException("Context for this Thread already defined");
+          Logger.Error("ERROR: Context for this Thread already defined. Will dispose it and then create a new one.");
+          RemoveContext();
+          RemoveAndCompleteTransaction();
         }
 
-        Logger.Debug("creating context");
         DisposableHiveDataContext context = CreateContext();
         context.OnDisposing += new EventHandler(context_OnDisposing);
@@ -59,6 +59,4 @@
         if (withTransaction) {
           TransactionScope transaction = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE });
-          Logger.Debug("creating  transaction");
-
           transactions.Add(threadId, transaction);
         }
@@ -72,10 +70,11 @@
 
     void context_OnDisposing(object sender, EventArgs e) {
-      RemoveContext();
-      RemoveAndCompleteTransaction();
+      lock (locker) {
+        RemoveContext();
+        RemoveAndCompleteTransaction();
+      }
     }
 
     public void RollbackTransaction() {
-      Logger.Debug("rolling back transaction");
       int threadId = Thread.CurrentThread.ManagedThreadId;
 
@@ -86,5 +85,4 @@
     public void RemoveContext() {
       lock (locker) {
-        Logger.Debug("removing context");
         int threadId = Thread.CurrentThread.ManagedThreadId;
 
@@ -96,12 +94,16 @@
     public void RemoveAndCompleteTransaction() {
       lock (locker) {
-        Logger.Debug("completing transaction");
         int threadId = Thread.CurrentThread.ManagedThreadId;
 
         // context does not always have an associated transaction
         if (transactions.ContainsKey(threadId)) {
-          transactions[threadId].Complete();
-          transactions[threadId].Dispose();
-          transactions.Remove(threadId);
+          try {
+            transactions[threadId].Complete();
+            transactions[threadId].Dispose();
+          }
+          catch (Exception) { }
+          finally {
+            transactions.Remove(threadId);
+          }
         }
       }
@@ -110,9 +112,11 @@
     public DataContext CurrentContext {
       get {
-        int threadId = Thread.CurrentThread.ManagedThreadId;
-        if (contexts.ContainsKey(threadId)) {
-          return contexts[threadId];
-        } else {
-          return null;
+        lock (locker) {
+          int threadId = Thread.CurrentThread.ManagedThreadId;
+          if (contexts.ContainsKey(threadId)) {
+            return contexts[threadId];
+          } else {
+            return null;
+          }
         }
       }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HeuristicLab.Hive.Server.LINQDataAccess-3.3.csproj
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HeuristicLab.Hive.Server.LINQDataAccess-3.3.csproj	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HeuristicLab.Hive.Server.LINQDataAccess-3.3.csproj	(revision 4423)
@@ -107,4 +107,5 @@
   <ItemGroup>
     <Compile Include="BaseDao.cs" />
+    <Compile Include="HiveExperimentDao.cs" />
     <Compile Include="SlaveConfigDao.cs" />
     <Compile Include="SlaveDao.cs" />
@@ -154,9 +155,14 @@
   </ItemGroup>
   <ItemGroup>
-    <Content Include="HiveDataContext.xml">
+    <None Include="HiveDataContext.dbml">
       <SubType>Designer</SubType>
-    </Content>
+    </None>
     <Content Include="Scripts\cleanHiveDatabase.sql" />
     <Content Include="Scripts\prepareHiveDatabase.sql" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HiveDataContext.dbml.layout">
+      <DependentUpon>HiveDataContext.dbml</DependentUpon>
+    </None>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HiveDataContext.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HiveDataContext.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.LINQDataAccess/3.3/HiveDataContext.cs	(revision 4423)
@@ -61,4 +61,7 @@
     partial void UpdateUptimeCalendar(UptimeCalendar instance);
     partial void DeleteUptimeCalendar(UptimeCalendar instance);
+    partial void InsertHiveExperiment(HiveExperiment instance);
+    partial void UpdateHiveExperiment(HiveExperiment instance);
+    partial void DeleteHiveExperiment(HiveExperiment instance);
     #endregion
 		
@@ -164,4 +167,12 @@
 			{
 				return this.GetTable<UptimeCalendar>();
+			}
+		}
+		
+		public System.Data.Linq.Table<HiveExperiment> HiveExperiments
+		{
+			get
+			{
+				return this.GetTable<HiveExperiment>();
 			}
 		}
@@ -587,5 +598,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UpDownTimeCalendar", DbType="Xml", UpdateCheck=UpdateCheck.Never)]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UpDownTimeCalendar", DbType="Xml", CanBeNull=false, UpdateCheck=UpdateCheck.Never)]
 		public System.Xml.Linq.XElement UpDownTimeCalendar
 		{
@@ -921,5 +932,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(MAX)")]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(MAX)", CanBeNull=false)]
 		public string Name
 		{
@@ -941,5 +952,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Version", DbType="VarChar(MAX)")]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Version", DbType="VarChar(MAX)", CanBeNull=false)]
 		public string Version
 		{
@@ -961,5 +972,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BuildDate", DbType="VarChar(20)")]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BuildDate", DbType="VarChar(20)", CanBeNull=false)]
 		public string BuildDate
 		{
@@ -1075,5 +1086,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(MAX)")]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(MAX)", CanBeNull=false)]
 		public string Name
 		{
@@ -1394,5 +1405,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(MAX)")]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(MAX)", CanBeNull=false)]
 		public string Name
 		{
@@ -1414,5 +1425,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceType", IsDiscriminator=true)]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceType", CanBeNull=false, IsDiscriminator=true)]
 		public string ResourceType
 		{
@@ -1834,5 +1845,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Slave_Job", Storage="_Jobs", ThisKey="ResourceId", OtherKey="ResourceId", DeleteRule="SET NULL")]
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Slave_Job", Storage="_Jobs", ThisKey="ResourceId", OtherKey="ResourceId")]
 		public EntitySet<Job> Jobs
 		{
@@ -1963,5 +1974,5 @@
 		private System.Nullable<System.Guid> _ResourceId;
 		
-		private System.Nullable<double> _Percentage;
+		private System.Nullable<System.TimeSpan> _ExecutionTime;
 		
 		private string _Exception;
@@ -1979,5 +1990,5 @@
 		private System.Nullable<System.Guid> _ProjectId;
 		
-		private System.Nullable<System.Guid> _UserId;
+		private System.Guid _UserId;
 		
 		private int _CoresNeeded;
@@ -2009,6 +2020,6 @@
     partial void OnResourceIdChanging(System.Nullable<System.Guid> value);
     partial void OnResourceIdChanged();
-    partial void OnPercentageChanging(System.Nullable<double> value);
-    partial void OnPercentageChanged();
+    partial void OnExecutionTimeChanging(System.Nullable<System.TimeSpan> value);
+    partial void OnExecutionTimeChanged();
     partial void OnExceptionChanging(string value);
     partial void OnExceptionChanged();
@@ -2025,5 +2036,5 @@
     partial void OnProjectIdChanging(System.Nullable<System.Guid> value);
     partial void OnProjectIdChanged();
-    partial void OnUserIdChanging(System.Nullable<System.Guid> value);
+    partial void OnUserIdChanging(System.Guid value);
     partial void OnUserIdChanged();
     partial void OnCoresNeededChanging(int value);
@@ -2088,5 +2099,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_JobState", DbType="VarChar(MAX)")]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_JobState", DbType="VarChar(MAX)", CanBeNull=false)]
 		public string JobState
 		{
@@ -2132,20 +2143,20 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Percentage", DbType="Float")]
-		public System.Nullable<double> Percentage
-		{
-			get
-			{
-				return this._Percentage;
-			}
-			set
-			{
-				if ((this._Percentage != value))
-				{
-					this.OnPercentageChanging(value);
-					this.SendPropertyChanging();
-					this._Percentage = value;
-					this.SendPropertyChanged("Percentage");
-					this.OnPercentageChanged();
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ExecutionTime", DbType="Time")]
+		public System.Nullable<System.TimeSpan> ExecutionTime
+		{
+			get
+			{
+				return this._ExecutionTime;
+			}
+			set
+			{
+				if ((this._ExecutionTime != value))
+				{
+					this.OnExecutionTimeChanging(value);
+					this.SendPropertyChanging();
+					this._ExecutionTime = value;
+					this.SendPropertyChanged("ExecutionTime");
+					this.OnExecutionTimeChanged();
 				}
 			}
@@ -2172,5 +2183,5 @@
 		}
 		
-		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SerializedJob", DbType="VarBinary(MAX)", UpdateCheck=UpdateCheck.Never)]
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SerializedJob", DbType="VarBinary(MAX)", CanBeNull=false, UpdateCheck=UpdateCheck.Never)]
 		public System.Data.Linq.Binary SerializedJob
 		{
@@ -2297,5 +2308,5 @@
 		
 		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UserId", DbType="UniqueIdentifier")]
-		public System.Nullable<System.Guid> UserId
+		public System.Guid UserId
 		{
 			get
@@ -2800,4 +2811,211 @@
 		}
 	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.HiveExperiment")]
+	public partial class HiveExperiment : INotifyPropertyChanging, INotifyPropertyChanged
+	{
+		
+		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
+		
+		private System.Guid _HiveExperimentId;
+		
+		private string _Name;
+		
+		private string _Description;
+		
+		private string _ResourceIds;
+		
+		private System.Guid _UserId;
+		
+		private System.Nullable<System.Guid> _RootJobId;
+		
+		private EntityRef<Job> _Job;
+		
+    #region Extensibility Method Definitions
+    partial void OnLoaded();
+    partial void OnValidate(System.Data.Linq.ChangeAction action);
+    partial void OnCreated();
+    partial void OnHiveExperimentIdChanging(System.Guid value);
+    partial void OnHiveExperimentIdChanged();
+    partial void OnNameChanging(string value);
+    partial void OnNameChanged();
+    partial void OnDescriptionChanging(string value);
+    partial void OnDescriptionChanged();
+    partial void OnResourceIdsChanging(string value);
+    partial void OnResourceIdsChanged();
+    partial void OnUserIdChanging(System.Guid value);
+    partial void OnUserIdChanged();
+    partial void OnRootJobIdChanging(System.Nullable<System.Guid> value);
+    partial void OnRootJobIdChanged();
+    #endregion
+		
+		public HiveExperiment()
+		{
+			this._Job = default(EntityRef<Job>);
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_HiveExperimentId", AutoSync=AutoSync.OnInsert, DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true, IsDbGenerated=true)]
+		public System.Guid HiveExperimentId
+		{
+			get
+			{
+				return this._HiveExperimentId;
+			}
+			set
+			{
+				if ((this._HiveExperimentId != value))
+				{
+					this.OnHiveExperimentIdChanging(value);
+					this.SendPropertyChanging();
+					this._HiveExperimentId = value;
+					this.SendPropertyChanged("HiveExperimentId");
+					this.OnHiveExperimentIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="VarChar(MAX)", CanBeNull=false)]
+		public string Name
+		{
+			get
+			{
+				return this._Name;
+			}
+			set
+			{
+				if ((this._Name != value))
+				{
+					this.OnNameChanging(value);
+					this.SendPropertyChanging();
+					this._Name = value;
+					this.SendPropertyChanged("Name");
+					this.OnNameChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Description", DbType="VarChar(MAX)")]
+		public string Description
+		{
+			get
+			{
+				return this._Description;
+			}
+			set
+			{
+				if ((this._Description != value))
+				{
+					this.OnDescriptionChanging(value);
+					this.SendPropertyChanging();
+					this._Description = value;
+					this.SendPropertyChanged("Description");
+					this.OnDescriptionChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceIds", DbType="VarChar(MAX)")]
+		public string ResourceIds
+		{
+			get
+			{
+				return this._ResourceIds;
+			}
+			set
+			{
+				if ((this._ResourceIds != value))
+				{
+					this.OnResourceIdsChanging(value);
+					this.SendPropertyChanging();
+					this._ResourceIds = value;
+					this.SendPropertyChanged("ResourceIds");
+					this.OnResourceIdsChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UserId", DbType="UniqueIdentifier")]
+		public System.Guid UserId
+		{
+			get
+			{
+				return this._UserId;
+			}
+			set
+			{
+				if ((this._UserId != value))
+				{
+					this.OnUserIdChanging(value);
+					this.SendPropertyChanging();
+					this._UserId = value;
+					this.SendPropertyChanged("UserId");
+					this.OnUserIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RootJobId", DbType="UniqueIdentifier")]
+		public System.Nullable<System.Guid> RootJobId
+		{
+			get
+			{
+				return this._RootJobId;
+			}
+			set
+			{
+				if ((this._RootJobId != value))
+				{
+					if (this._Job.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnRootJobIdChanging(value);
+					this.SendPropertyChanging();
+					this._RootJobId = value;
+					this.SendPropertyChanged("RootJobId");
+					this.OnRootJobIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Job_HiveExperiment", Storage="_Job", ThisKey="RootJobId", OtherKey="JobId", IsForeignKey=true, DeleteRule="CASCADE")]
+		public Job RootJob
+		{
+			get
+			{
+				return this._Job.Entity;
+			}
+			set
+			{
+				if ((this._Job.Entity != value))
+				{
+					this.SendPropertyChanging();
+					this._Job.Entity = value;
+					this.SendPropertyChanged("RootJob");
+				}
+			}
+		}
+		
+		public event PropertyChangingEventHandler PropertyChanging;
+		
+		public event PropertyChangedEventHandler PropertyChanged;
+		
+		protected virtual void SendPropertyChanging()
+		{
+			if ((this.PropertyChanging != null))
+			{
+				this.PropertyChanging(this, emptyChangingEventArgs);
+			}
+		}
+		
+		protected virtual void SendPropertyChanged(String propertyName)
+		{
+			if ((this.PropertyChanged != null))
+			{
+				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+			}
+		}
+	}
 }
 #pragma warning restore 1591
